/*
  Designed by LinJiangHua(xempo) 2004-2006,2008-2010
  Copyright 2004-06 Linjianghua(xempo).
  All Rights Reserve.
*/
#define IsEmpty(dys,dir) DirFix(dys,p_DirFlags,dir)

bool IsInPath(Dysto *dys,DIRE *dir,DIRE *chkdir)
{
long adr=0;
if(dir==NULL)return false;
if(chkdir){
  DIRE *pdir=chkdir;
  adr=pdir->selfaddr;
  while(adr!=dir->selfaddr&&(adr=pdir->parDir)>0){
	if(pdir!=chkdir)Release(dys,pdir);
	pdir=DirRead(dys,adr);
  }
  if(pdir!=chkdir)Release(dys,pdir);
}
return (adr==dir->selfaddr);
}

void *RSeekDir(Dysto *lib,DIRE *Dir,int Msg)
{
if(Dir){
char *pth, *pr;
DIRE *ptdir=lib->cDir;
long adr=Dir->parDir;
if(adr<1)switch(Msg){
		case 2 : return Dir->password? NULL:SPC;
		case 1 : return catstr(NULL,Dir->name,'\\');
		case 0 : return Dir;
		}
pth=Dir->name;
do{
  Release(lib,ptdir);
  ptdir=DirRead(lib,adr);
  DirInit(lib,ptdir);
  adr=ptdir->parDir;
  switch(Msg){
  case 2 : if(ptdir->password){ Release(lib,ptdir); return NULL; }
	break;
  case 1 : 
	pr=pth;
	pth=catstr(ptdir->name,pth,'\\');
	if(pr!=Dir->name)free(pr);
	}
}while(adr>0);
if(Msg==0)return ptdir;
Release(lib,ptdir);
if(Msg==2)return SPC;/* password prevent data */
pr=catstr(NULL, pth, '\\');	free(pth);
return pr;
}
return NULL;
}

int DysSizMdf(Dysto *dys,DIRE *dir,void *parm)
{
int step=*(int *)parm;
dys->DirCnt+=step;
dys->cn+=dir->cn*step;
dys->use+=dir->sz*step;
return 0;
}

void RemoveDir(Dysto *dys,DIRE *pDir0,DIRE *dir,int step)
{
DysSizMdf(dys,dir,&step);
dys->use+=dys->DirSize*step;
dys->mdf|=1;
/*if(dys->verNo){*/	/* no need to limit */
if(dir->parDir){
     DIRE *_dir=pDir0;
     if(pDir0==NULL||dir->parDir!=pDir0->selfaddr)pDir0=DirRead(dys,dir->parDir);
	pDir0->dircnt+=step;	pDir0->sz+=step*(dir->sz+dys->DirSize);
	pDir0->cn-=dir->cn;	pDir0->mdf|=1;
	if(_dir!=pDir0)_release(dys,pDir0);
	}
else dys->rootcn+=step;
  DirExpr(dys,dir->subDir,DysSizMdf,&step);
  dir->usemsg=step>0? 1:2;
  dir->date=_CurDate(dys->mdf);
  dkwrite(dys,dir,DirFlagPos,dir->selfaddr);
}

void DirModify(Dysto *dys,const char *oldNam,const char *newNam)
{/* newNam=NULL is Del, nor Rename */
DIRE *Dir=DirOpen(dys,oldNam);
if(Dir){
  DIRE *tstdir,
  *pDir0=Dir->parDir? DirRead(dys,Dir->parDir):NULL;
  if(newNam){/* rename */
     long adr=Dir->parDir? pDir0->subDir:dys->DirAdr;
     tstdir=DirFix(dys,newNam,adr);
     if(tstdir){
	popMsg(plusInfo[10],newNam,1);
	Release(dys,tstdir);
	}
     else if(NamStrCpy(Dir->name,newNam,dys->verNo? DirNamLen:18))Dir->mdf|=1;
	  else puts(plusInfo[DysMsg]);
  }
  else {/* deldir */
    if(IsInPath(dys,Dir,dys->cDir))puts(usagMsg[17]);
    else RemoveDir(dys,pDir0,Dir,-1);
    }
  Release(dys,pDir0);
  Release(dys,Dir);
    }
}